'********************
'* Version:	20170731


' ps = pathset
' no = number
' vol = volumn
' cap = capacity
' net = network

ps_no = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("No", False)
ps_from_zone_no = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("FromZoneNo", False)
ps_to_zone_no = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("ToZoneNo", False)
ps_sequence_of_zones = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("rs_zone_sequence", False)
ps_vol = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("Vol", False)
ps_matched_path_id = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("rs_matched_path_id", False)
ps_replaced_path_id = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("rs_replaced_path_id", False)
ps_cap = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("rs_capacity", False)
net_veh_cap = Visum.Net.AttValue("Vehicle_Capacity")

For i = 0 To UBound(ps_no)                                                                                        ' loop:     i = Supplier
    For j = 0 To UBound(ps_no)                                                                                    ' loop:     j = Demander                                                                         ' exit:     RS_BefPers = 0
        ' check:	fromzone in sequence of zones and 
		'			tozone in sequence of zones and 
		'			fromzone before tozone in sequence of zones
		If InStr(1, ps_sequence_of_zones(i, 1), ps_from_zone_no(j, 1)) > 0 And _
           InStr(1, ps_sequence_of_zones(i, 1), ps_to_zone_no(j, 1)) > 0 And _
           InStr(1, ps_sequence_of_zones(i, 1), ps_from_zone_no(j, 1)) <= _
           InStr(1, ps_sequence_of_zones(i, 1), ps_to_zone_no(j, 1)) And _
           ps_vol(j, 1) <> 0 And _
           ps_cap(i, 1) > 0 And _
           i <> j Then																																																	
            If ps_cap(i, 1) >= ps_vol(j, 1) Then
                ps_cap(i, 1) = ps_cap(i, 1) - ps_vol(j, 1)
				ps_cap(j, 1) = 0
                ps_vol(i, 1) = ps_vol(i, 1) + ps_vol(j, 1)
                ps_matched_path_id(i, 1) = ps_matched_path_id(i, 1) & "," & ps_no(j, 1) & "(" & ps_vol(j, 1) & ")"
                ps_replaced_path_id(j, 1) = ps_replaced_path_id(j, 1) & "," & ps_no(i, 1) & "(" & ps_vol(j, 1) & ")"
                ps_vol(j, 1) = 0
            Else
				ps_vol(i, 1) = ps_vol(i, 1) + ps_cap(i, 1)
                ps_vol(j, 1) = ps_vol(j, 1) - ps_cap(i, 1)
                ps_matched_path_id(i, 1) = ps_matched_path_id(i, 1) & "," & ps_no(j, 1) & "(" & ps_cap(i, 1) & ")"
                ps_replaced_path_id(j, 1) = ps_replaced_path_id(j, 1) & "," & ps_no(i, 1) & "(" & ps_cap(i, 1) & ")"
                ps_cap(i, 1) = 0
                ps_cap(j, 1) = Round(ps_vol(j, 1) / net_veh_cap + 0.5) * net_veh_cap - ps_vol(j, 1)
            End If
        End If
    Next
Next

' write information back to Visum
Call Visum.Net.PathSets.ItemByKey(2).Paths.SetMultiAttValues("rs_satisfied_demand", ps_vol) 
Call Visum.Net.PathSets.ItemByKey(2).Paths.SetMultiAttValues("rs_matched_path_id", ps_matched_path_id)
Call Visum.Net.PathSets.ItemByKey(2).Paths.SetMultiAttValues("rs_replaced_path_id", ps_replaced_path_id)
Call Visum.Net.PathSets.ItemByKey(2).Paths.SetMultiAttValues("rs_capacity", ps_cap)