' **************************
' * Version: 20170731


PathSetNo 		= Visum.Net.AttValue("NoPathSet")

sequence_of_zones 	= Visum.Net.PathSets.ItemByKey(PathSetNo).Paths.GetMultiAttValues("Concatenate:Nodes\node_intersect_with_zones", false)			
from_zone_no 		= Visum.Net.PathSets.ItemByKey(PathSetNo).Paths.GetMultiAttValues("FromZoneNo", false)				
to_zone_no 			= Visum.Net.PathSets.ItemByKey(PathSetNo).Paths.GetMultiAttValues("ToZoneNo", false)				

For i = 0 To UBound(sequence_of_zones)
	sequence_of_zones(i, 1) = "," & from_zone_no(i, 1) & "," & sequence_of_zones(i, 1) & "," & to_zone_no(i, 1) & ","		' add: 		zone origin and destination to ensure origin and destination are part of the sequence
	sequence_of_zones(i, 1) = zone_sequence(sequence_of_zones(i, 1))														' call: 	function to reduce the zone sequence, keep necessary information about the route
Next

call Visum.Net.PathSets.ItemByKey(PathSetNo).Paths.SetMultiAttValues("rs_zone_sequence", sequence_of_zones)					' return:	reduced zone sequence to Visum

' uniques the sequence of (main)zones by keeping the order
Function zone_sequence(vSeq)										
	vSeq = Replace(vSeq, ".", "")																							' replace string "." by ""			
	vSeq = Split(vSeq, ",")																									' split string by ","
	For j = 0 To UBound(vSeq) - 1                                                                           	
        If vSeq(j) <> vSeq(j + 1) And vSeq(j) <> "" Then
            zone_sequence = zone_sequence & "," & vSeq(j)                                                     		' if zone exist then consider otherwise continue with next entry
        End If
    Next                                                                                                    
	If Len(zone_sequence) > 0 Then zone_sequence = Right(zone_sequence, Len(zone_sequence) - 1)			' remove first "," in string zone_sequence
	zone_sequence = zone_sequence & ","
    vSeq = Split(zone_sequence, ",")
    zone_sequence = ""
    For j = 0 To UBound(vSeq) - 1                                                                         		
        If vSeq(j) <> vSeq(j + 1) Then
            zone_sequence = zone_sequence & "," & vSeq(j)                                                     		' if zone exist then consider otherwise continue with next entry
        End If
    Next 
    If Len(zone_sequence) > 0 Then zone_sequence = Right(zone_sequence, Len(zone_sequence) - 1)                		' remove first "," in string zone_sequence
End Function