' **************************
' * Version: 20170731

zone_no = Visum.Net.Zones.GetMultiAttValues("NO")
ps_fromzoneno = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("FROMZONENO", True)
ps_tozoneno = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("TOZONENO", True)
ps_vol = Visum.Net.PathSets.ItemByKey(2).Paths.GetMultiAttValues("rs_satisfied_demand", True)

no_vehtrips_route_match = 13
veh_capacity = Visum.Net.AttValue("Vehicle_Capacity")
non_integer_vehicle_trips = Visum.Net.AttValue("non_integer_vehicle_trips")

Visum.Net.Matrices.ItemByKey(no_vehtrips_route_match).Init
matrix_values = Visum.Net.Matrices.ItemByKey(no_vehtrips_route_match).GetValues

For i = 0 To UBound(ps_fromzoneno)
    zone_from_index = bin_search(zone_no, ps_fromzoneno(i, 1))
    zone_to_index = bin_search(zone_no, ps_tozoneno(i, 1))
	If non_integer_vehicle_trips = False Then
		matrix_values(zone_from_index, zone_to_index) = ps_vol(i, 1) / veh_capacity
	Else
		matrix_values(zone_from_index, zone_to_index) = 1
	End If
Next

Visum.Net.Matrices.ItemByKey(no_vehtrips_route_match).SetValues matrix_values

'_____________________________________________________________________________________________________________________________________________________
'binary search algorithm
Function bin_search(arr, srch)
   first = LBound(arr)
   last = UBound(arr)
   Do Until cancel = -1 And first <= last
      middle = (first + last) \ 2
      If arr(middle, 1) = srch Then
         cancel = middle
         Exit Do
      Else
         If srch > arr(middle, 1) Then
            first = middle + 1
         Else
            last = middle - 1
         End If
      End If
   Loop
   bin_search = middle
End Function